////////////////////////////////////////////////////////////////////
//  Copyright 2002 Hewlett-Packard Company                       //
// Developer: Jason Junkin                                        //
//            email: Jason.Junkin@hp.com                          //
//                                                                //
//                                                                //
//   FILE SUMMARY -- hpsort.cpp                                   //
//                                                                //
//   $Log: /MDA/build/linux/field/diagnostics/html/hpsort.js $    //
//                                                                //
//                                                                //
//                                                                //
//                                                                //
////////////////////////////////////////////////////////////////////

var table;
var rowArray = new Array();
var titleRowArray = new Array();
var titleRowCellArray = new Array();
var titleSpanCellArray = new Array();
var colSpanArray = new Array();
var colTitleFilled = new Array();
var sortIndex;
var descending = parent.parent.frames.menuFrame.document.logMenuForm.descending.value;
var nRow, actualNRow, maxNCol;
var origColor;
var isIE;
var linkEventString =
	'onMouseOver=\'setCursor(this);' +
	'setColor(this,"selected");\' ' +
	'onMouseOut=\'setColor(this,"default");\' ' +
	'onClick=\'sortTable(';


var ascChr = "^";
var desChr = "v";
var selectedColor = "blue";
var defaultColor = "black";
var recDelimiter = '|';		
var titleFace = 'b';			
var updownColor = 'gray';	

function initTable(obj)
{
	if (! checkBrowser()) return;

	var countCol;
	var nChildNodes;
	var innerMostNode;
	var nColSpan, nRowSpannedTitleCol, colPos;
	var cell, cellText;
	var titleFound = false;
	var rNRowSpan, rNColSpan;

	if (obj.tagName == "TABLE")
	{
		table = obj;
	}
	else
	{
		table = document.getElementById(obj);
	}

	if (table == null) return;

	if (table.tagName != "TABLE") return;

	maxNCol = table.rows[table.rows.length-1].cells.length;

	rowArray = new Array();
	colSpanArray = new Array();
	colTitleFilled = new Array();
	titleRowArray = new Array();
	titleRowCellArray = new Array();
	
	for (var i=0; i<maxNCol; i++)
		colTitleFilled[i] = false;

	nRow = table.rows.length;	

	if (nRow < 1) return;

	actualNRow = 0;			// Number of actual data rows
	rNRowSpan = 0;			// Remaining rows in the row span
	rNColSpan = 0;			// Remaining cols in the col span
	nRowSpannedTitleCol = 0;	// Number of title cols from row span
		
	for (var i=0; i<nRow; i++)
	{
		nColSpan = 1, colPos = 0;

		for (var j=0; j<table.rows[i].cells.length; j++)
		{
			if (titleFound == false)
			{
				if (table.rows[i].cells[j].rowSpan > 1)
				{
					if (table.rows[i].cells[j].colSpan < 2)
					{
						titleSpanCellArray[colPos] =
							table.rows[i].cells[j];
						colTitleFilled[colPos] = true;
						nRowSpannedTitleCol++;
					}
					if (table.rows[i].cells[j].rowSpan - 1 
						> rNRowSpan)
					{
						rNRowSpan = 
							table.
							rows[i].cells[j].
							rowSpan - 1;

						if (table.rows[i].
							cells[j].colSpan > 1)
							rNColSpan = 
								rNRowSpan + 1;
					}
				}
			}
			if (table.rows[i].cells[j].colSpan > 1 &&
				rNColSpan == 0)
			{ 
				nColSpan = table.rows[i].cells[j].colSpan;
				colPos += nColSpan;
			}
			else
			{
				colPos++;
			}		
		}
					
		if (titleFound == false && nColSpan == 1 && 
			rNRowSpan == 0 && rNColSpan == 0 && titleFound == false)
		{
			colSpanArray[i] = true;
			titleFound = true;

			countCol = 0;
			for (var j=0; 
				j<table.rows[i].cells.length
					+ nRowSpannedTitleCol; j++)
			{
				if (colTitleFilled[j] != true)
				{
					titleRowCellArray[j] =
						table.rows[i].cells[countCol];
					countCol++;
				}
				else
				{
					titleRowCellArray[j] = 
						titleSpanCellArray[j];
				}
			}
		}
		else if (titleFound == true && nColSpan == 1 && rNRowSpan == 0)
		{
			for (var j=0; j<table.rows[i].cells.length; j++)
			{
				if (table.rows[i].cells[j].rowSpan > 1) return;
				nChildNodes =
					table.rows[i].
					cells[j].firstChild.childNodes.
					length;

				innerMostNode = 
					table.rows[i].
					cells[j].firstChild;

				while ( nChildNodes != 0)
				{
					innerMostNode =
						innerMostNode.
						firstChild;
					nChildNodes =
						innerMostNode.
						childNodes.
						length;
				}

				if (j == 0)
				{
					rowArray[actualNRow] = 
						innerMostNode.data;
				}
				else
				{
					rowArray[actualNRow] += recDelimiter +
						innerMostNode.data;
				}
			}
			if (table.rows[i].cells.length > maxNCol)
				return;
			actualNRow++;
			colSpanArray[i] = false;
		}
		else if (nColSpan == 1 && rNRowSpan == 0 && 
			rNColSpan == 0 && titleFound == false)
		{
			colSpanArray[i] = false;
		}
		else
		{
			colSpanArray[i] = true;
		}
		
		if (rNRowSpan > 0) rNRowSpan--;
		if (rNColSpan > 0) rNColSpan--;
	}

	if (actualNRow < 1) return;

	for (var j=0; j<maxNCol; j++)
	{
		if (titleRowCellArray[j].childNodes.length == 0) return;
		if (titleRowCellArray[j].firstChild != null)
		{
			nChildNodes = 
				titleRowCellArray[j].
				firstChild.childNodes.length;
			innerMostNode = 
				titleRowCellArray[j].firstChild;

			while ( nChildNodes != 0)
			{
				innerMostNode =
					innerMostNode.firstChild;
				nChildNodes =
					innerMostNode.
					childNodes.
					length;
			}
			cellText = innerMostNode.data;
		}
		else
		{
			cellText = "column(" + j + ")";
		}
		titleRowArray[j] = cellText;
		titleRowCellArray[j].innerHTML =
			'<a ' +
			linkEventString +
			j + ',' + '"' + table.id + '"' + ');\'>' + 
			'<' + titleFace + '>' + cellText + 
			'</' + titleFace +'></a>';
	}
}

function sortTable(index,obj,rem)
{

  if (!rem)
  {
	  if (descending=="true")
    {
      parent.parent.frames.menuFrame.document.logMenuForm.descending.value = "false";
		  descending = "false";
    }
	  else
    {
      parent.parent.frames.menuFrame.document.logMenuForm.descending.value = "true";
		  descending = "true";
    }
  }
  else
  {
	  if (descending=="true")
    {
      parent.parent.frames.menuFrame.document.logMenuForm.descending.value = "true";
		  descending = "true";
    }
	  else
    {
      parent.parent.frames.menuFrame.document.logMenuForm.descending.value = "false";
		  descending = "false";
    }
  }





	initTable(obj);

	var nChildNodes;
	var innerMostNode;
	var rowContent;
	var rowCount;
	var cell, cellText;
	var newTitle;

  parent.parent.frames.menuFrame.document.logMenuForm.row2Sort.value = index;
	
	if (index < 0 || index >= maxNCol) return;
	
	sortIndex = index;
	rowArray.sort(compare);

	for (var j=0; j<maxNCol; j++)
	{
		cellText = titleRowArray[j];
		cellText = '<' + titleFace +'>' +
			cellText + '</' + titleFace + '></a>';
		newTitle = '<a ' +
			linkEventString +
			j + ',' + '"' + table.id + '"' + ');\'>' +
			cellText +
			'</a>';
		if (j == sortIndex)
		{
			newTitle += '&nbsp;<font color=' + updownColor + '>';
      if (descending=="true")
  		  newTitle += desChr;
		  else
			  newTitle += ascChr;
			newTitle += '</font>';
		}
		titleRowCellArray[j].innerHTML = newTitle;
	}

	rowCount = 0;
	for (var i=0; i<nRow; i++)
	{
		if (! colSpanArray[i])
		{
			for (var j=0; j<maxNCol; j++)
			{
				rowContent = rowArray[rowCount].
					split(recDelimiter);
				nChildNodes =
					table.rows[i].cells[j].firstChild.
					childNodes.length;
				innerMostNode = 
					table.rows[i].cells[j].firstChild;

				while ( nChildNodes != 0)
				{
					innerMostNode =
						innerMostNode.firstChild;
					nChildNodes =
						innerMostNode.
						childNodes.
						length;
				}
				innerMostNode.data = rowContent[j];
			}
			rowCount++;
		}
	}
}

function compare(a, b)
{
	var aRowContent = a.split(recDelimiter);
	var bRowContent = b.split(recDelimiter);
	
	var aToBeCompared, bToBeCompared;

	if (! isNaN(aRowContent[sortIndex]))
		aToBeCompared = parseInt(aRowContent[sortIndex], 10);
	else
		aToBeCompared = aRowContent[sortIndex];

	if (! isNaN(bRowContent[sortIndex]))
		bToBeCompared = parseInt(bRowContent[sortIndex], 10);
	else
		bToBeCompared = bRowContent[sortIndex];

	if (aToBeCompared < bToBeCompared)
		if (descending=="false")
		{
			return -1;
		}
		else
		{
			return 1;
		}
	if (aToBeCompared > bToBeCompared)
		if (descending=="false")
		{
			return 1;
		}
		else
		{
			return -1;
		}
	return 0;
}

function setCursor(obj)
{
	window.status = "Sort by " + obj.firstChild.innerHTML;
	if (isIE)
		obj.firstChild.style.cursor = "hand";
	else
		obj.firstChild.style.cursor = "pointer";
}

function setColor(obj,mode)
{
	if (mode == "selected")
	{
		if (obj.style.color != selectedColor) 
			defaultColor = obj.style.color;
		obj.style.color = selectedColor;
	}
	else
	{	
		obj.style.color = defaultColor;
		window.status = '';
	}
}

function checkBrowser()
{
	if (navigator.appName == "Microsoft Internet Explorer"
		&& navigator.appVersion.indexOf("5.") >= 0)
	{
		isIE = true;
		return true;
	}
	else if (navigator.appName == "Netscape"
		&& navigator.appVersion.indexOf("5.") >= 0)
	{
		isIE = false;
		return true;
	}
	else
		return false;
}
