#!/bin/sh
#
# install_diags.sh - install the diagnostic kernel-mode driver
#

DRIVER="hpdvmkd.o"
DEVICE="/dev/hpdvmkd"
MAJORNUM=60

if test "$UID" != "0"
then
  echo "$0: only the superuser (root) may run this command" >&2
  exit 1
elif test ! -f "$DRIVER"
then
  echo "$0: $DRIVER not found" >&2
  exit 1
elif test -n "`lsmod | grep hpdvmkd`"
then
  echo "$0: diagnostics are already installed on this system" >&2
  exit 1
fi

rm -f $DEVICE
insmod $DRIVER || exit 1
mknod $DEVICE c $MAJORNUM 0 || exit 1

exit 0

